/*
 * Created on Jun 1, 2005
 *
 * Unpublished Work, Copyright, 2004 Northrop Grumman
 */
package gov.grants.apply.util;

import java.net.URL;
import java.util.Enumeration;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.xml.parsers.FactoryConfigurationError;

import org.apache.log4j.Appender;
import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public final class InitServlet
	extends HttpServlet
{
   private static final String LOG4J_CONFIG_FILE = "log4j.xml";
   public static final Logger LOG = Logger.getLogger(InitServlet.class);

   public void init()
   	throws ServletException
   {
      if (LOG.isDebugEnabled())
      {
         LOG.debug("Initializing RI server.");
         LOG.debug(Debug.locateClass(LOG));
         Enumeration appenders = LOG.getAllAppenders();
         Appender appender = null;
         while (appenders != null && appenders.hasMoreElements())
         {
            appender = (Appender) appenders.nextElement();
            LOG.debug("Appender used: " + appender.getName());
         }
         LOG.debug("That's all the appenders.");
         LOG.debug("Properties from application.properties: " + PropertiesLoader.list("application.properties"));
      }
      WebAppContext.getInstance().setServletContext(getServletContext());
      
      URL log4jXmlFile = getClass().getClassLoader().getResource(LOG4J_CONFIG_FILE);
      if (log4jXmlFile == null)
      {
         System.err.println("Unable to find/load " + LOG4J_CONFIG_FILE + " that should be in the web applicaiton's classpath.");
      }
      else
      {
         try
         {
            DOMConfigurator.configure(log4jXmlFile);
         }
         catch (FactoryConfigurationError e)
         {
            e.printStackTrace();
            System.err.println("Unable to configure log4j with log4j.xml file in classpath.");
         }
      }

      
   }
}
