/*
 * Created on Jun 2, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.dao;

import gov.grants.apply.util.NestedException;

/**
 * @author Grants.gov WebServices Team
 *
 * A Nested exception type object representing exceptional situations occurring within
 * DAO classes.  This class extends NestedException, which is a work around when using
 * JDK version 1.3.
 */
public final class DAOException
   extends NestedException
{
   /**
    * Create a DAOException with a customized error message.
    * @param message A customized error message
    */
   public DAOException(String message)
   {
      super(message);
   }
   
   /**
    * Create a DAOException with a customized error message and the original throwable
    * object.
    * @param message A customized error message
    * @param cause  The original throwable object.
    */
   public DAOException(String message, Throwable cause)
   {
      super(message, cause);
   }
   
   /**
    * Create a DAOException with the original throwable object.
    * @param cause  The original throwable object.
    */
   public DAOException(Throwable cause)
   {
      super(cause);
   }
}
