/*
 * Created on May 16, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationResponse;
import gov.grants.apply.util.Constants;

/**
 * @author Grants.gov WebServices Team
 *
 * Processes the GetApplication WebService:
 * <pre>
 * &lt;xsd:element name="GetApplicationRequest"&gt;
 *    &lt;xsd:complexType&gt;
 *       &lt;xsd:sequence&gt;
 *          &lt;xsd:element ref="footer:Grants_govTrackingNumber"/&gt;
 *       &lt;/xsd:sequence&gt;
 *    &lt;/xsd:complexType&gt;
 * &lt;/xsd:element&gt;
 * &lt;xsd:element name="GetApplicationResponse"&gt;
 *    &lt;xsd:complexType&gt;
 *       &lt;xsd:sequence&gt;
 *          &lt;xsd:element name="SubmittedApplication" type="xsd:anyType"/&gt;
 *       &lt;/xsd:sequence&gt;
 *    &lt;/xsd:complexType&gt;
 * &lt;/xsd:element&gt;
 * </pre>
 */
public interface IGetApplicationProcessor
{
   public static final String DEFAULT_ENCODING_TYPE = Constants.MIME_ENCODING_TYPE;
   public static final String DOT_XML_EXT = ".xml";
   public static final String XML_CONTENT_TYPE = "text/xml";
   
   /**
    * Process the web service request.
    * @param request The Axis GetApplication request.
    * @return An object representing the GetApplicationResponse element.
    * @throws ProcessorException When the request could not be serviced.
    */
   public GetApplicationResponse process(GetApplicationRequest request) throws ProcessorException;
}
