/*
 * Created on Jun 3, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws.production;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GrantsGovApplicationStatusType;
import gov.grants.apply.ws.IGetApplicationListBean;

import java.util.Calendar;
import java.util.GregorianCalendar;

import com.trw.InFlowSuiteCustomization.Grants_gov.CustomerDefinedClasses.wswrapper.ApplicationListInfo;

/**
 * @author Grants.gov WebServices Team
 *
 * Wrapper for ApplicationListInfo class from IFS component.
 */
public final class ApplicationInfoFromGGWSWrapper implements IGetApplicationListBean
{
   private ApplicationListInfo _info = null;
   private String _ifsDateString = null;
   
   public ApplicationInfoFromGGWSWrapper(ApplicationListInfo info)
   {
      _info = info;
   }
   
   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getCfdaNumber()
    */
   public String getCfdaNumber()
   {
      return _info.getCfdaNumber();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getCompetitionId()
    */
   public String getCompetitionId()
   {
      return _info.getCompetitionId();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getOpportunityNumber()
    */
   public String getOpportunityNumber()
   {
      return _info.getOpportunityNumber();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getStatus()
    */
   public GrantsGovApplicationStatusType getStatus()
   {
      String status = _info.getStatus();
      if (GrantsGovApplicationStatusType._value1.equals(status))
      {
         return GrantsGovApplicationStatusType.value1;
      }
      else if (GrantsGovApplicationStatusType._value2.equals(status))
      {
         return GrantsGovApplicationStatusType.value2;
      }
      else if (GrantsGovApplicationStatusType._value3.equals(status))
      {
         return GrantsGovApplicationStatusType.value3;
      }
      else if (GrantsGovApplicationStatusType._value4.equals(status))
      {
         return GrantsGovApplicationStatusType.value4;
      }
      else if (GrantsGovApplicationStatusType._value5.equals(status))
      {
         return GrantsGovApplicationStatusType.value5;
      }
      else if (GrantsGovApplicationStatusType._value6.equals(status))
      {
         return GrantsGovApplicationStatusType.value6;
      }
      else if (GrantsGovApplicationStatusType._value7.equals(status))
      {
         return GrantsGovApplicationStatusType.value7;
      }
      else if (GrantsGovApplicationStatusType._value8.equals(status))
      {
         return GrantsGovApplicationStatusType.value8;
      }
      else
      {
         return null;
      }
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getSubmissionTitle()
    */
   public String getSubmissionTitle()
   {
      return _info.getSubmissionTitle();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getTrackingNumber()
    */
   public String getTrackingNumber()
   {
      return _info.getTrackingNumber();
   }

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListBean#getTimestamp()
    */
   public Calendar getReceivedDate()
   {
      Calendar cal = new GregorianCalendar();
      cal.setTime(_info.getReceivedDate());
      return cal;
   }

   public void setIFSDateString(String date)
   {
      _ifsDateString = date;
   }
   
   public String getIFSDateString()
   {
      return _ifsDateString;
   }
}
