/*
 * Created on Jun 7, 2005
 *
 * Unpublished Work, Copyright, 2005 Northrop Grumman
 */
package gov.grants.apply.ws.production;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ConfirmApplicationDeliveryRequest;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ConfirmApplicationDeliveryResponse;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ResponseMessage;
import gov.grants.apply.util.AxisUtils;
import gov.grants.apply.util.ProcessorUtils;
import gov.grants.apply.ws.IConfirmApplicationDeliveryProcessor;
import gov.grants.apply.ws.ProcessorException;

import org.apache.log4j.Logger;

import com.trw.InFlowSuiteCustomization.Grants_gov.CustomerDefinedClasses.GGWSWrapper;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public final class ConfirmApplicationDeliveryProdModeProcessor
   implements IConfirmApplicationDeliveryProcessor
{
   private static final Logger LOG = Logger.getLogger(ConfirmApplicationDeliveryProdModeProcessor.class);

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IConfirmApplicationDeliveryProcessor#process(gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.ConfirmApplicationDeliveryRequest)
    */
   public ConfirmApplicationDeliveryResponse process(ConfirmApplicationDeliveryRequest request)
      throws ProcessorException
   {
      String trackingNum = request.getGrants_govTrackingNumber();
      if (trackingNum == null)
      {
         throw new ProcessorException("Tracking number is null.");
      }
      try
      {
         GGWSWrapper.confirmApplicationDelivery(GGWSWrapper.getID(AxisUtils.getCurrentHttpRequest()), trackingNum);
      }
      catch (Exception e)
      {
         throw new ProcessorException("Failed to confirm application delivery.", e);
         //return ProcessorUtils.prepareConfirmAppDeliveryResponse(ResponseMessage.Failure, trackingNum);
      }
      return ProcessorUtils.prepareConfirmAppDeliveryResponse(ResponseMessage.Success, trackingNum);
   }

}
