/*
 * Created on May 16, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gov.grants.apply.ws.standAloneMode;

import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationListRequestApplicationFilter;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationListRequestApplicationFilterFilter;
import gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0.GetApplicationListResponse;
import gov.grants.apply.dao.AgencyDAOFactory;
import gov.grants.apply.dao.Application;
import gov.grants.apply.dao.DAOException;
import gov.grants.apply.dao.GetApplicationListFilter;
import gov.grants.apply.dao.IApplicationDAO;
import gov.grants.apply.util.ProcessorUtils;
import gov.grants.apply.ws.IGetApplicationListBean;
import gov.grants.apply.ws.IGetApplicationListProcessor;
import gov.grants.apply.ws.ProcessorException;

import org.apache.log4j.Logger;

/**
 * @author Grants.gov WebServices Team
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public final class GetApplicationListSAModeProcessor
	implements IGetApplicationListProcessor
{
   private final static Logger LOG = Logger.getLogger(GetApplicationListSAModeProcessor.class);
   private final static AgencyDAOFactory FACTORY = AgencyDAOFactory.getFactory();

   /* (non-Javadoc)
    * @see gov.grants.apply.ws.IGetApplicationListProcessor#process(gov.grants.apply.WebServices.AgencyIntegrationServices_V1_0._GetApplicationListRequest)
    */
   public GetApplicationListResponse process(GetApplicationListRequestApplicationFilter[] filters)
   	throws ProcessorException
   {
      LOG.debug("Processing request.");
      GetApplicationListFilter filter = new GetApplicationListFilter();
      for (int i = 0; filters != null && i < filters.length && filters[i] != null; i++)
      {
         if (filters[i].getFilter() == GetApplicationListRequestApplicationFilterFilter.CFDANumber)
         {
            filter.setCfdaNum(filters[i].getFilterValue());
         }
         else if (filters[i].getFilter() == GetApplicationListRequestApplicationFilterFilter.OpportunityID)
         {
            filter.setOppID(filters[i].getFilterValue());
         }
         else if (filters[i].getFilter() == GetApplicationListRequestApplicationFilterFilter.Status)
         {
            filter.setStatus(filters[i].getFilterValue());
         }
      }
      if (LOG.isDebugEnabled())
      {
         LOG.debug("getApplicationList filter CFDA: " + filter.getCfdaNum());
         LOG.debug("getApplicationList filter Opportunity ID: " + filter.getOppID());
         LOG.debug("getApplicationList filter Status: " + filter.getStatus());
      }
      IApplicationDAO appDao = FACTORY.createApplicationDAO();
      Application[] apps = null;
      try
      {
         apps = appDao.findApplications(filter);
      }
      catch (DAOException e)
      {
         throw new ProcessorException("Failed during search for applications", e);
      }
      
      IGetApplicationListBean[] appInfos = new IGetApplicationListBean[apps.length];
      for (int i = 0; i < apps.length; i++)
      {
         appInfos[i] = new ApplicationInfoFromDAO(apps[i]);
      }
      LOG.debug("Sending response.");
      return ProcessorUtils.prepareGetApplicationListResponse(appInfos);
   }

}
